aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorArtem Savkov <asavkov@redhat.com>2016-08-30 09:39:07 +0200
committerEryu Guan <eguan@redhat.com>2016-08-31 17:33:22 +0800
commit0dea6dc3eaba902347d0fefd249bbe16b493ae4f (patch)
tree542ca8209e669332a6cbcdbc64d40652f0a27d95
parent2c4033964d48cf225e72abddfbe4032f2ea7555a (diff)
downloadxfstests-dev-0dea6dc3eaba902347d0fefd249bbe16b493ae4f.tar.gz
generic: listxattr syscall with different buffer sizes
Add test that calls listxattr syscall with different buffer size arguments checking if it fails properly. Signed-off-by: Artem Savkov <asavkov@redhat.com> Reviewed-by: Eryu Guan <eguan@redhat.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rw-r--r--.gitignore1
-rw-r--r--src/Makefile2
-rw-r--r--src/listxattr.c73
-rwxr-xr-xtests/generic/37787
-rw-r--r--tests/generic/377.out11
-rw-r--r--tests/generic/group1
6 files changed, 174 insertions, 1 deletions
diff --git a/.gitignore b/.gitignore
index d84f385adf..915d2d8a49 100644
--- a/.gitignore
+++ b/.gitignore
@@ -66,6 +66,7 @@
/src/holes
/src/holetest
/src/itrash
+/src/listxattr
/src/locktest
/src/loggen
/src/looptest
diff --git a/src/Makefile b/src/Makefile
index 57b0df11e8..dd51216b8a 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -21,7 +21,7 @@ LINUX_TARGETS = xfsctl bstat t_mtab getdevicesize preallo_rw_pattern_reader \
stale_handle pwrite_mmap_blocked t_dir_offset2 seek_sanity_test \
seek_copy_test t_readdir_1 t_readdir_2 fsync-tester nsexec cloner \
renameat2 t_getcwd e4compact test-nextquota punch-alternating \
- attr-list-by-handle-cursor-test
+ attr-list-by-handle-cursor-test listxattr
SUBDIRS =
diff --git a/src/listxattr.c b/src/listxattr.c
new file mode 100644
index 0000000000..cd46637aa0
--- /dev/null
+++ b/src/listxattr.c
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2016 Red Hat, Inc. All Rights Reserved.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it would be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/xattr.h>
+
+int main(int argc, char **argv)
+{
+ int ret;
+ size_t bufsize = 0;
+ char *buf = NULL;
+
+ if (argc < 2) {
+ fprintf(stderr, "usage: %s <testfile> [bufsize]\n", argv[0]);
+ return 1;
+ };
+
+ if (argc > 2) {
+ bufsize = strtoul(argv[2], NULL, 10);
+ if (bufsize == -1) {
+ perror("buffsize");
+ return 1;
+ }
+ }
+
+ if (bufsize == 0) {
+ bufsize = listxattr(argv[1], NULL, 0);
+ if (bufsize == -1) {
+ perror("listxattr");
+ return 1;
+ }
+ }
+
+ buf = malloc(bufsize);
+ if (buf == NULL) {
+ perror("buf alloc");
+ return 1;
+ }
+
+ ret = listxattr(argv[1], buf, bufsize);
+ if (ret < 0) {
+ perror("listxattr");
+ } else {
+ char *l;
+ for (l = buf; l != (buf + bufsize) && *l != '\0';
+ l = strchr(l, '\0') + 1) {
+ printf("xattr: %s\n", l);
+ }
+ }
+
+ free(buf);
+
+ return 0;
+}
diff --git a/tests/generic/377 b/tests/generic/377
new file mode 100755
index 0000000000..79b6416b14
--- /dev/null
+++ b/tests/generic/377
@@ -0,0 +1,87 @@
+#! /bin/bash
+# FSQA Test No. 377
+#
+# Test listxattr syscall behaviour with different buffer sizes.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat, Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation, either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, see <http://www.gnu.org/licenses/>.
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_attrs
+_require_test_program "listxattr"
+
+listxattr="$here/src/listxattr"
+
+rm -f $seqres.full
+
+_scratch_mkfs >>$seqres.full 2>&1
+_scratch_mount
+
+# Create a testfile with three xattrs such that the sum of namelengths of the
+# first two is bigger than the namelength of the third. This is needed for
+# the 5th testcase that tests one of the cornercases.
+testfile=${SCRATCH_MNT}/testfile
+touch $testfile
+$SETFATTR_PROG -n user.foo -v bar $testfile
+$SETFATTR_PROG -n user.ping -v pong $testfile
+$SETFATTR_PROG -n user.hello -v there $testfile
+
+# 1. Call listxattr without buffer length argument. This should succeed.
+$listxattr $testfile | sort
+
+# 2. Calling listxattr on nonexistant file should fail with -ENOENT.
+$listxattr ""
+
+# 3. Calling listxattr with buffersize not suffecient for even one xattr
+# should fail with -ERANGE.
+$listxattr $testfile 1
+
+# 4. Calling listxattr with buffersize suffecient for one xattr, but not
+# sufficient for the whole list should still fail with -ERANGE.
+$listxattr $testfile 9
+
+# 5. Calling listxattr with buffersize suffecient for the last xattr, but not
+# sufficient for the sum of first two. Should fail with -ERANGE.
+$listxattr $testfile 11
+
+# 6. Calling listxattr with buffersize bigger than needed should succeed.
+$listxattr $testfile 500 | sort
+
+status=0
+exit
diff --git a/tests/generic/377.out b/tests/generic/377.out
new file mode 100644
index 0000000000..2b388c2c5a
--- /dev/null
+++ b/tests/generic/377.out
@@ -0,0 +1,11 @@
+QA output created by 377
+xattr: user.foo
+xattr: user.hello
+xattr: user.ping
+listxattr: No such file or directory
+listxattr: Numerical result out of range
+listxattr: Numerical result out of range
+listxattr: Numerical result out of range
+xattr: user.foo
+xattr: user.hello
+xattr: user.ping
diff --git a/tests/generic/group b/tests/generic/group
index bad71bcce6..2b2ee8bf24 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -379,3 +379,4 @@
374 auto quick clone dedupe
375 auto quick acl
376 auto quick metadata
+377 attr auto quick metadata